﻿using System;
using System.Text.Json.Serialization;

namespace SharpChat.Misuzu {
    public class MisuzuAuthInfo {
        [JsonPropertyName("success")]
        public bool Success { get; set; }

        [JsonPropertyName("reason")]
        public string Reason { get; set; } = "none";

        [JsonPropertyName("user_id")]
        public long UserId { get; set; }

        [JsonPropertyName("username")]
        public string UserName { get; set; }

        [JsonPropertyName("colour_raw")]
        public int ColourRaw { get; set; }

        public ChatColour Colour => ChatColour.FromMisuzu(ColourRaw);

        [JsonPropertyName("hierarchy")]
        public int Rank { get; set; }

        [JsonPropertyName("is_silenced")]
        public DateTimeOffset SilencedUntil { get; set; }

        [JsonPropertyName("perms")]
        public ChatUserPermissions Permissions { get; set; }
    }
}
